$(document).ready(function() {
    $('select').wrap('<span class="s_select"></span>');
    $('.s_select').append('<button class="s_choosen"></button><ul class="s_select_body"></ul>');
    $('select').each(function() {
        var options = [], values = [], x;
        $(this).children('option').each(function() {
            options.push($(this).html());
            values.push($(this).attr('value'));
        });
        $(this).next('.s_choosen').html(options[0]);
        var selectBody = $(this).nextAll('.s_select_body');
        for (x in options) {
            selectBody.append('<li val="' + values[x] + '">' + options[x] + '</li>');
        }
    });

    $('.s_choosen').click(function(event) {
        var that = this;
        var selectBody = $(this).next('.s_select_body');
        var selectList = selectBody.children('li');

        if (!selectBody.hasClass("selected")) {
            console.log(false);
            $('body').off('.s_select_body');

            selectBody.addClass("selected");

            setTimeout(function() {
                $("body").one("click.s_select_body", function() {
                    $('.s_select_body').each(function() {
                        $(this).removeClass('selected');
                        $(document).off('.s_select_keydown');
                    });
                });
            }, 1);

            var _S_ = {
                select: {
                    itemId: -1,
                    totalNum: selectList.length - 1
                }};

            $(document).on('keydown.s_select_keydown', function(event) {
                selectList.each(function() {
                    $(this).addClass('keyboard');
                });

                $(selectList).one('mousemove', function() {
                    _S_.select.itemId = -1;
                    selectList.each(function() {
                        $(this).removeClass('selected keyboard');
                    });
                });

                function changeItem() {
                    if (_S_.select.itemId < 0)
                        _S_.select.itemId = _S_.select.totalNum;
                    if (_S_.select.itemId > _S_.select.totalNum)
                        _S_.select.itemId = 0;

                    selectList.each(function() {
                        $(this).removeClass("selected");
                    });

                    $(selectList[_S_.select.itemId]).addClass("selected");
                }

                if (event.which === 38) {
                    _S_.select.itemId -= 1;
                    changeItem();
                }
                if (event.which === 40) {
                    _S_.select.itemId += 1;
                    changeItem();
                }

                if (event.which === 13) {
                    $(that).blur();
                    $(selectList[_S_.select.itemId]).click();
                }

            });

            $('.s_select_body>li').click(function() {
                var selectObject = $(this).parents('.s_select').children('select');
                selectObject.val($(this).attr('val'));
                selectObject.next('.s_choosen').html($(this).html());
                $(document).off(".s_select");

                selectObject.nextAll('.s_select_body').removeClass('selected');
            });

            event.preventDefault();

        } else {
            $("body").click();
        }
    });
});